/* ALTERNATE DOL DATABASE for USB Loader mrc */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <ogcsys.h>

#include "selectdol.h"


#define WMP_VIDEO	"WM+ video"
#define GAME		"Game"
#define MENU		"Menu"
#define TUTORIAL	"Tutorial"
#define EPISODE_1	"Episode 1"
#define EPISODE_2	"Episode 2"
#define EPISODE_3	"Episode 3"
#define EPISODE_4	"Episode 4"
#define EPISODE_5	"Episode 5"
#define EPISODE_6	"Episode 6"
#define MPRIME_1	"Metroid Prime"
#define MPRIME_2	"Metroid Prime 2"
#define MPRIME_3	"Metroid Prime 3"


#define MAX_ALTDOLS 57
altDol altDols[MAX_ALTDOLS]={
	// == WII MOTION PLUS VIDEO ==
	{"RZTP",	WMP_VIDEO,	952,		0x00},	//Wii Sports Resort
	{"RZTE",	WMP_VIDEO,	674,		0x00},
	{"RVUP",	WMP_VIDEO,	16426,		0x00},	//Virtua Tennis 2009
	{"RVUE",	WMP_VIDEO,	16405,		0x00},
	{"R9OP",	WMP_VIDEO,	1991,		0x00},	//Tiger Woods 10
	{"R9OE",	WMP_VIDEO,	1973,		0x00},
	{"R5TP",	WMP_VIDEO,	1493,		0x00},	//Grand Slam Tennis
	{"RD2X",	WMP_VIDEO,	301,		0x00},	//Red Steel 2
	{"R22P",	WMP_VIDEO,	1785,		0x00},	//Fling Smash

	// == GAMES THAT NEED ALT DOL ==
	{"RF8P",	GAME,	463,		0x00},	//Fifa 08
	{"RF8E",	GAME,	439,		0x00},
	{"RF8X",	GAME,	464,		0x00},
	{"RMDP",	GAME,	39,			0x00},	//Madden NFL07
	{"RNFP",	GAME,	1079,		0x00},	//Madden NFL08
	{"RNBX",	GAME,	964,		0x00},	//NBA 08
	{"RMZ",		GAME,	492,		0x00},	//Medal of Honor: Heroes
	{"RM2P",	GAME,	517,		0x00},	//Medal of Honor: Heroes 2
	{"RM2E",	GAME,	492,		0x00},
	{"RM2X",	GAME,	601,		0x00},
	{"RKM",		GAME,	290,		0x00},	//Mortal Kombat Armageddon
	{"RPYP",	GAME,	12490,		0x00},	//Pangya Golf
	{"RED",		GAME,	1957,		0x00},	//Redsteel
	{"RBO",		GAME,	675,		0x00},	//Boogie
	{"RSX",		GAME,	377,		0x00},	//SSX Blur

	// == EXTRA GAMES ==
	{"RMLP",	"Metal Slug 6",	56,			0x00},	//Metal Slug Anthology
	{"RMLE",	"Metal Slug 6",	54,			0x00},
	{"RHD",		"HotD 2",		149,		0x00},	//The House Of The Dead 2 & 3 Return
	{"RJ8",		"Atlantis",		8,			0x00},	//Indiana Jones and the King Staff
	{"S3MP",	"Multiplayer",	129,		0x00},	//The Sims 3 (Multiplayer mode)

	// == MULTIPLE GAMES ==
	{"RPGP",	"World Tour",	369,		0x00},	//Rampage: Total Destruction
	{"RPGP",	"Rampage",		368,		0x00},
	{"SR5P",	"Rabbids",		136,		0x00},	//Rayman Collection
	{"SR5P",	"Rabbids 2",	320,		0x00},
	{"SR5P",	"TV Party",		905,		0x00},
	{"R3X",		MENU,	0,			0x01},	//Sam & Max Season One
	{"R3X",		TUTORIAL,	0,			0x11},
	{"R3X",		EPISODE_1,	0,			0x19},
	{"R3X",		EPISODE_2,	0,			0x21},
	{"R3X",		EPISODE_3,	0,			0x29},
	{"R3X",		EPISODE_4,	0,			0x31},
	{"R3X",		EPISODE_5,	0,			0x39},
	{"R3X",		EPISODE_6,	0,			0x41},
	{"R3Y",		MENU,	0,			0x01},	//Sam & Max Season Two
	{"R3Y",		TUTORIAL,	0,			0x11},
	{"R3Y",		EPISODE_1,	0,			0x19},
	{"R3Y",		EPISODE_2,	0,			0x21},
	{"R3Y",		EPISODE_3,	0,			0x29},
	{"R3Y",		EPISODE_4,	0,			0x31},
	{"R3Y",		EPISODE_5,	0,			0x39},
	{"R3MP",	MPRIME_1,	782,		0x00},	//Metroid Prime Trilogy PAL
	{"R3MP",	MPRIME_2,	783,		0x00},
	{"R3MP",	MPRIME_3,	784,		0x00},
	{"R3ME",	MPRIME_1,	780,		0x00},	//Metroid Prime Trilogy NTSC
	{"R3ME",	MPRIME_2,	781,		0x00},
	{"R3ME",	MPRIME_3,	782,		0x00},
	{"SP2P",	"Sports",	1285,		0x00},	//Wii Sports+Resort PAL
	{"SP2P",	"Resort",	932,		0x00}
};


/*static dolNames dols[]={
	//FILENAME			PARAM	DESCRIPTION
	//=========================================================================================
	{"player",			0x00,	"WM+ video"},		// 00: Wii Motion+ Video
	{"game",			0x00,	"Game"},			// 01: Fifa 08, NBA 08 & MOH: Heroes 2
	{"madden",			0x00,	"Game"},			// 02: Madden NFL 07
	{"maddens",			0x00,	"Game"},			// 03: Madden NFL 08
	{"redsteel",		0x00,	"Game"},			// 04: Red Steel
	{"ssx",				0x00,	"Game"},			// 05: SSX Blur & Boogie
	{"mk7",				0x00,	"Game"},			// 06: Mortal Kombat Armaggedon
	{"PangyaRev",		0x00,	"Game"},			// 07: Pangya! Golf with style
	{"ms6",				0x00,	"Metal Slug 6"},	// 08: Metal Slug Anthology
	{"hod2",			0x00,	"HotD 2"},			// 09: The house of the dead 2 & 3: Returns
	{"FateAtlantis",	0x00,	"Atlantis"},		// 10: Indiana Jones & King Staff
	{"mplr",			0x00,	"Multiplayer"},		// 11: The Sims 3
	{"jarvos",			0x00,	"World Tour"},		// 12: Rampage: Total Destruction
	{"M1",				0x00,	"Rampage"},			// 13: Rampage: Total Destruction
	{"rrr1_f",			0x00,	"Rabbids"},			// 14: Rayman Raving Rabbids Party Collection
	{"rrr2_eu",			0x00,	"Rabbids 2"},		// 15: Rayman Raving Rabbids Party Collection
	{"rrr3_noe",		0x00,	"TV Party"},		// 16: Rayman Raving Rabbids Party Collection
	{"main",			0x01,	"Menu"},			// 17: Sam & Max Seasons One & Two
	{"main",			0x11,	"Tutorial"},		// 18: Sam & Max Seasons One & Two
	{"main",			0x19,	"Episode 1"},		// 19: Sam & Max Seasons One & Two
	{"main",			0x21,	"Episode 2"},		// 20: Sam & Max Seasons One & Two
	{"main",			0x29,	"Episode 3"},		// 21: Sam & Max Seasons One & Two
	{"main",			0x31,	"Episode 4"},		// 22: Sam & Max Seasons One & Two
	{"main",			0x39,	"Episode 5"},		// 23: Sam & Max Seasons One & Two
	{"main",			0x41,	"Episode 6"},		// 24: Sam & Max Seasons One & Two
	{"rs5m?1_?",		0x00,	"Metroid Prime"},	// 25: Metroid Prime Trilogy
	{"rs5m?2_?",		0x00,	"Metroid Prime 2"},	// 26: Metroid Prime Trilogy
	{"rs5m?3_?",		0x00,	"Metroid Prime 3"},	// 27: Metroid Prime Trilogy
	{"WiiSports2P",		0x00,	"Wii Sports",		// 28: Wii Sports+Resort
	{"SportsPackEP",		0x00,	"Wii Sports Resort"}// 29: Wii Sports+Resort
};

const altDol altDolGames[]={
	//====  MOTION+ GAMES  ===================================
	{"RZT", 1, 0},	// 00: Wii Sports Resort
	{"R22", 1, 0},	// 01: FlingSmash
	{"RD2", 1, 0},	// 02: Red Steel 2
	{"R5T", 1, 0},	// 03: Grand Slam Tennis
	{"R9O", 1, 0},	// 04: Tiger Woods 10
	{"STW", 1, 0},	// 05: Tiger Woods 11
	{"RVU", 1, 0},	// 06: Virtua Tennis 2009
	{"R5F", 1, 0},	// 07: Academy of Champions: Soccer
	{"R5V", 1, 0},	// 08: James Cameron's Avatar: The Game
	{"R6I", 1, 0},	// 09: Baseball Blast!
	{"R7O", 1, 0},	// 10: NHL 2K10
	{"SH3", 1, 0},	// 11: NHL 2K11
	{"R8I", 1, 0},	// 12: SpongeBob's Truth or Square
	{"SAD", 1, 0},	// 13: Backyard Sports: Sandlot Sluggers
	{"SG2", 1, 0},	// 14: Crazy Mini Golf
	{"SG7", 1, 0},	// 15: The Garfield Show
	{"SKT", 1, 0},	// 16: All Star Karate
	{"SPP", 1, 0},	// 17: Power Punch
	{"SRQ", 1, 0},	// 18: Racquet Sports
	//========================================================
	{"RF8", 1, 1},	// 19: Fifa 08
	{"RNB", 1, 1},	// 20: NBA 08
	{"RM2", 1, 1},	// 21: Medal of honor: Heroes 2
	{"RMD", 1, 2},	// 22: Madden NFL 07
	{"RNF", 1, 3},	// 23: Madden NFL 08
	{"RED", 1, 4},	// 24: Red Steel
	{"RSX", 1, 5},	// 25: SSX Blur
	{"RBO", 1, 5},	// 26: Boogie
	{"RKM", 1, 6},	// 27: Mortal Kombat Armaggedon
	{"RPY", 1, 7},	// 28: Pangya! Golf with style
	{"RML", 1, 8},	// 29: Metal Slug Anthology
	{"RHD", 1, 9},	// 30: The house of the dead 2 & 3: Returns
	{"RJ8", 1, 10},	// 31: Indiana Jones & King Staff
	{"S3M", 1, 11},	// 32: The Sims 3
	{"RPG", 2, 12},	// 33: Rampage: Total Destruction
	{"SR5", 3, 14},	// 34: Rayman Raving Rabbids Party Collection
	{"R3X", 8, 17},	// 35: Sam & Max Season One
	{"R3Y", 7, 17},	// 36: Sam & Max Season Two
	{"R3M", 3, 25},	// 37: Metroid Prime Trilogy
};*/

altDol* select_dol_from_internal_db(const char *id, int dol){
	int i;

	for(i=0; i<MAX_ALTDOLS; i++){
		if(id[0]==altDols[i].id[0] && id[1]==altDols[i].id[1] && id[2]==altDols[i].id[2]){

			if(strlen(altDols[i].id)==4 && id[3]!=altDols[i].id[3]){
				continue;
			}
			dol--;
			if(dol==0)
				return &altDols[i];
		}
	}

    return 0;
}

